// 自定义bind方法 -- for ios 5 safari
if (!Function.prototype.bind) {
    Function.prototype.bind = function (oThis) {
        if (typeof this !== "function") {
            // closest thing possible to the ECMAScript 5 internal IsCallable function
            throw new TypeError("Function.prototype.bind - what is trying to be bound is not callable");
        }
        
        var aArgs = Array.prototype.slice.call(arguments, 1),
        fToBind = this,
        fNOP = function () {},
        fBound = function () {
            return fToBind.apply(this instanceof fNOP && oThis
                                 ? this
                                 : oThis,
                                 aArgs.concat(Array.prototype.slice.call(arguments)));
        };
        
        fNOP.prototype = this.prototype;
        fBound.prototype = new fNOP();
        
        return fBound;
    };
}
var jfpal = {
    runState:"",
    token:"",
    safeAjax: function(url, data, success, failed) {
        var paraArr = new Array();
        paraArr.push(url);
        paraArr.push(data);
        var exec = cordova.require('cordova/exec');
        exec(function(data){
                     success(data);
                     }, 
             function(err) {
                     failed(err);
                     }, 
              "ConnectionPlugin", "safeAjax", paraArr);
    },
    callSafepayService: function(paraStr,success, fail){
        var paraArr = new Array();
        paraArr.push(paraStr);
        var exec = cordova.require('cordova/exec');
        exec(function(){}, function(){}, "SafePayClass", "callSafepayService", paraArr);
    },
	jfPay: function(data, success, fail) {
        var paraArr = new Array();
        paraArr.push(data);
        var exec = cordova.require('cordova/exec');
        exec(success, fail, "SafePayClass", "doPay", paraArr);
	},
    tradePay: function(data, success, fail) {
        var paraArr = new Array();
        paraArr.push(data);
        var exec = cordova.require('cordova/exec');
        exec(success, fail, "SafePayClass", "doService", paraArr);
    },
    login: function(){
        var paraArr = new Array();
        var exec = cordova.require('cordova/exec');
        exec(function(){}, function(){}, "WebAppContext", "login", paraArr);
    },
    map:{
        location: function(lat,lon,label){
            var paraArr = new Array();
            paraArr.push(lat);
            paraArr.push(lon);
            paraArr.push(label);
            var exec = cordova.require('cordova/exec');
            exec(function(){}, function(){}, "MapPlugin", "location", paraArr);
        },
        route: function(slat,slon,dlat,dlon,mode){
            var paraArr = new Array();
            paraArr.push(slat);
            paraArr.push(slon);
            paraArr.push(dlat);
            paraArr.push(dlon);
            paraArr.push(mode);
            var exec = cordova.require('cordova/exec');
            exec(function(){}, function(){}, "MapPlugin", "route", paraArr);
        }
    },
    geolocation:{
        getCurrentPosition:function(successCallback, errorCallback, options) {
            var geo = cordova.require('cordova/plugin/geolocation');
            geo.getCurrentPosition(successCallback, errorCallback, options);
        },
        lastLocation: {}
    },
    analysis:{
        event: function(eventKey,eventValue,viewId){
            var paraArr = new Array();
            paraArr.push(eventKey);
            paraArr.push(eventValue);
            paraArr.push(viewId);
            
            for(var i =3; i<arguments.length; i++){
                paraArr.push(arguments[i]);
            }
            var exec = cordova.require('cordova/exec');
            exec(function(){}, function(){}, "Analysis", "event", paraArr);
        },
        jumpPage: function(current,target){
            var paraArr = new Array();
            paraArr.push(current);
            paraArr.push(target);
            var exec = cordova.require('cordova/exec');
            exec(function(){}, function(){}, "Analysis", "jumpPage", paraArr);        
        }
    },
    setting:{
        setDefaultBackFunction: function(backFun){
            var paraArr = new Array();
            paraArr.push(backFun);
            var exec = cordova.require('cordova/exec');
            exec(function(){}, function(){}, "NavigationClass", "setDefaultBackFunction", paraArr);
        }
    },
    user: {
        account:"",
        name:"",
        messageCount:0,
        mobileNo:"",
        userID:"",
        fire:function(){
            var exec = cordova.require('cordova/exec');
            var callBack = function (resultData){
                try {
                    //jfpal.user.account = resultData.id;
                    //jfpal.user.name = resultData.name;
                    //jfpal.user.messageCount = 0;
                    jfpal.user.mobileNo = resultData.mobileNo
                    //jfpal.user.userID = resultData.id;
                    //jfpal.session.token = resultData.token;
                } catch (e) {
                    console.log("Error in userinfo callback: "+e);
                }
            };
            exec(callBack, callBack, "UserInfoClass", "getInfo", []);
        }
    },
    session: {
        sessionID:"",
        clientID:"",
        token:""
    },
    context: {
        isLogin:false,
        userHistory:"",
        startApp: function(packageID,pageID,success,fail){
            var paraArr = new Array();
            paraArr.push(pageID);
            paraArr.push(packageID);
            var exec = cordova.require('cordova/exec');
            exec(success, fail, "WebAppContext", "go", paraArr);
        },
        quit: function(callback){
            var exec = cordova.require('cordova/exec');
            exec(callback, callback, "WebAppContext", "quite", []);
            cordova.require('cordova/channel').onCordovaInfoReady.fired = false;
        },
        getLoginUsers:function(success){
            var exec = cordova.require('cordova/exec');
            exec(success, success, "WebAppContext", "userCache", []);
        }
    },
    barScan: function(success, failed){
        var scanner = cordova.require("cordova/plugin/BarcodeScanner");
        scanner.scan(
                     success, failed
                     );
    },
    navigation:{
        navBar: null,
        init: function(){
            this.navBar = cordova.require('cordova/plugin/NavigationBar'),
            this.navBar.handle("init", []);
            this.navBar.handle("create", [{"style":"Default"}]);
        },
        slaverightitem:{
            setTitle: function(title){
                this.navBar.handle("setSlaverightTitle", [title]);
            },
            setIcon: function(icon){
                this.navBar.handle("setSlaverightIcon", [icon]);
            }
        },
        rightitem:{
            setTitle: function(title){
                this.navBar.handle("setRightTitle", [title]);
            },
            setIcon: function(icon){
                this.navBar.handle("setRightIcon", [icon]);
            }
        },
        leftitem:{
            setTitle: function(title){
                this.navBar.handle("setLeftTitle", [title]);
            },
            setIcon: function(icon){
                this.navBar.handle("setLeftIcon", [icon]);
            }
        },
        setCenterItemAction: function(actioin){
            this.navBar.handle("setCenterItemAction", [actioin]);
        },
        setRightItemAction: function(actioin){
            this.navBar.handle("setRightItemAction", [actioin]);
        },
        setLeftItemAction: function(action){
            this.navBar.handle("setLeftItemAction", [action]);
        },
        show: function() {
            this.navBar.handle("show", []);
        },
        setupLeftButton: function(title, image, callback) {
            var devicePlatform = device.platform;
            if (devicePlatform == "Android" || devicePlatform == "BlackBerry" || devicePlatform == "WinCE" || devicePlatform == "Win32NT" ) {
                document.addEventListener("backbutton", function(){
                                          console.log("backButton clicked");
                                          callback();
                                          }, false);
                console.log(callback);
            }
            this.navBar.leftButtonCallback = callback;
            
            var paraArr = new Array();
            paraArr.push(title);
            paraArr.push(image);
            paraArr.push({});
            
            this.navBar.handle("setupLeftButton", paraArr);
        },
        setupRightButton: function(title, image, callback) {
            this.navBar.rightButtonCallback = callback;
            
            var paraArr = new Array();
            paraArr.push(title);
            paraArr.push(image);
            paraArr.push({});

            this.navBar.handle("setupRightButton", paraArr);
        },
        setTitle: function(title){
            this.navBar.handle("setTitle", [title]);
        },
        setRightItemTitle: function(title){
            if(title == "") {
                this.navBar.handle("hideRightButton", [{}]);
                return;
            }
            
            var paraArr = new Array();
            paraArr.push(title);
            paraArr.push("v2_right_add_normal.png");
            paraArr.push({});
            
            this.navBar.rightButtonCallback = function(){
                if(C && C.Config && C.Config.rightBar) {
                    C.Config.rightBar();
                }
            };
            
            this.navBar.handle("setupRightButton", paraArr);
        },
        hideRightButton: function(animated) {
            if(animated == undefined)
                animated = false;
            this.navBar.handle("hideRightButton", [{"animated":animated}]);
        }
    }
        /*
        pushWindow: function(path){
            var paraArr = new Array();
            paraArr.push(path);
            
            this.navBar.handle("pushWindow", paraArr);
        },
        popWindow: function(msg){
            var paraArr = new Array();
            if(msg == undefined){
                paraArr.push('');
            }else{
                paraArr.push(msg);
            }
            this.navBar.handle("popWindow", paraArr);
            
            cordova.require('cordova/channel').onCordovaInfoReady.fired = false;
        },
        popToRoot: function(msg){
            var paraArr = new Array();
            if(msg == undefined){
                paraArr.push('');
            }else{
                paraArr.push(msg);
            }
            
            this.navBar.handle("popWindow", paraArr);
            
            var exec = cordova.require('cordova/exec');
            exec(function(){}, function(){}, "NavigationClass", "popToRoot", paraArr);
            cordova.require('cordova/channel').onCordovaInfoReady.fired = false;
        }
    },
    progress:{
        open: function(msg){
            var paraArr = new Array();
            paraArr.push(msg);
            var exec = cordova.require('cordova/exec');
            exec(function(){}, function(){}, "Progress", "open", paraArr);
        },
        close: function(){
            var exec = cordova.require('cordova/exec');
            exec(function(){}, function(){}, "Progress", "close", [""]);
        }
    }*/
};
